import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.concurrent.CountDownLatch;

public class Director {

  private static BufferedReader reader =
    new BufferedReader(new InputStreamReader(System.in));

  public static void doSomethingElse() {
    System.out.println("Hit return to continue.");
    try {
      String ignore = reader.readLine();
    } catch (Exception ex) {
    }
  }

  public static void main(String[] args) throws InterruptedException {

    final int N = 10;

    CountDownLatch startSignal = new CountDownLatch(1);
    CountDownLatch doneSignal = new CountDownLatch(N);

    for (int i = 0; i < N; ++i) {
      // create and start threads
      new Thread(new Worker(startSignal, doneSignal, i)).start();
    }

    doSomethingElse();            // don't let run yet
    startSignal.countDown();      // let all threads proceed
    doneSignal.await();           // wait for all to finish
    doSomethingElse();
    System.out.println("All done!");
  }
}
